### Struct

# Adw SpringParams

since: 1

#### Description [src]

    struct AdwSpringParams {
      /* No available fields */
    }

Physical parameters of a spring for `AdwSpringAnimation`.

Any spring can be described by three parameters: mass, stiffness and damping.

An undamped spring will produce an oscillatory motion which will go on forever.

The frequency and amplitude of the oscillations will be determined by the stiffness (how “strong” the spring is) and its mass (how much “inertia” it has).

If damping is larger than 0, the amplitude of that oscillating motion will exponientally decrease over time. If that damping is strong enough that the spring can’t complete a full oscillation, it’s called an overdamped spring.

If we the spring can oscillate, it’s called an underdamped spring.

The value between these two behaviors is called critical damping; a critically damped spring will comes to rest in the minimum possible time without producing oscillations.

The damping can be replaced by damping ratio, which produces the following springs:

- 0: an undamped spring.
- Between 0 and 1: an underdamped spring.
- 1: a critically damped spring.
- Larger than 1: an overdamped spring.

As such.

Available since: 1

#### Constructors

###### adw_spring_params_new

Creates a new `AdwSpringParams` from `mass`, `stiffness` and `damping_ratio`.

since: 1

###### adw_spring_params_new_full

Creates a new `AdwSpringParams` from `mass`, `stiffness` and `damping`.

since: 1

#### Instance methods

###### adw_spring_params_get_damping

Gets the damping of `self`.

since: 1

###### adw_spring_params_get_damping_ratio

Gets the damping ratio of `self`.

since: 1

###### adw_spring_params_get_mass

Gets the mass of `self`.

since: 1

###### adw_spring_params_get_stiffness

Gets the stiffness of `self`.

since: 1

###### adw_spring_params_ref

Increases the reference count of `self`.

since: 1

###### adw_spring_params_unref

Decreases the reference count of `self`.

since: 1